/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// Formality the model 'Formality'
type Formality string

// List of Formality
const (
	FormalityPreferLess Formality = "prefer_less"
	FormalityPreferMore Formality = "prefer_more"
)

// All allowed values of Formality enum
var AllowedFormalityEnumValues = []Formality{
	"prefer_less",
	"prefer_more",
}

func (v *Formality) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := Formality(value)
	for _, existing := range AllowedFormalityEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid Formality", value)
}

// NewFormalityFromValue returns a pointer to a valid Formality
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewFormalityFromValue(v string) (*Formality, error) {
	ev := Formality(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for Formality: valid values are %v", v, AllowedFormalityEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v Formality) IsValid() bool {
	for _, existing := range AllowedFormalityEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to Formality value
func (v Formality) Ptr() *Formality {
	return &v
}

type NullableFormality struct {
	value *Formality
	isSet bool
}

func (v NullableFormality) Get() *Formality {
	return v.value
}

func (v *NullableFormality) Set(val *Formality) {
	v.value = val
	v.isSet = true
}

func (v NullableFormality) IsSet() bool {
	return v.isSet
}

func (v *NullableFormality) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFormality(val *Formality) *NullableFormality {
	return &NullableFormality{value: val, isSet: true}
}

func (v NullableFormality) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFormality) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

